Package ec.gp.koza

# Class MutationPipeline

java.lang.Object
ec.BreedingSource
ec.BreedingPipeline
ec.gp.GPBreedingPipeline
ec.gp.koza.MutationPipeline

All Implemented Interfaces:
  `Prototype`, `Setup`, `SteadyStateBSourceForm`, `RandomChoiceChooserD`, `Serializable`, `Cloneable`

public class MutationPipeline extends GPBreedingPipeline
MutationPipeline is a GPBreedingPipeline which implements a strongly-typed version of the "Point Mutation" operator as described in Koza I. Actually, that's not quite true. Koza doesn't have any tree depth restrictions on his mutation operator. This one does -- if the tree gets deeper than the maximum tree depth, then the new subtree is rejected and another one is tried. Similar to how the Crosssover operator is implemented.

Mutated trees are restricted to being `maxdepth` depth at most and at most `maxsize` number of nodes. If in `tries` attemptes, the pipeline cannot come up with a mutated tree within the depth limit, then it simply copies the original individual wholesale with no mutation.

One additional feature: if `equal` is true, then MutationPipeline will attempt to replace the subtree with a tree of approximately equal size. How this is done exactly, and how close it is, is entirely up to the pipeline's tree builder -- for example, Grow/Full/HalfBuilder don't support this at all, while RandomBranch will replace it with a tree of the same size or "slightly smaller" as described in the algorithm.

Typical Number of Individuals Produced Per `produce(...)` call
...as many as the child produces

Number of Sources
1

Parameters

base.`tries` int >= 1 | (number of times to try finding valid pairs of nodes)
base.`maxdepth` int >= 1 | (maximum valid depth of a crossed-over subtree)
base.`maxsize` int >= 1 | (maximum valid size, in nodes, of a crossed-over subtree)
base.`ns` classname, inherits and != GPNodeSelector | (GPNodeSelector for tree)
base.`build`.0 classname, inherits and != GPNodeBuilder | (GPNodeBuilder for new subtree)
`equal` bool = `true` or `false` (default) | (do we attempt to replace the subtree with a new one of roughly the same size?)
base.`tree.0` 0 < int < (num trees in individuals), if exists | (tree chosen for mutation; if parameter doesn't exist, tree is picked at random)

Default Base
gp.koza.mutate

Parameter bases

base.`ns` | nodeselect
base.`build` | builder

See Also:
  - Serialized Form

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `GPNodeBuilder`
  `builder`
  How the pipeline builds a new subtree
  `static final int`
  `INDS_PRODUCED`
  `int`
  `maxSize`
  The largest tree (measured as a nodecount) the pipeline is allowed to form.
  `static final int`
  `NO_SIZE_LIMIT`
  `GPNodeSelector`
  `nodeselect`
  How the pipeline chooses a subtree to mutate
  `static final int`
  `NUM_SOURCES`
  `static final String`
  `P_BUILDER`
  `static final String`
  `P_EQUALSIZE`
  `static final String`
  `P_MAXDEPTH`
  `static final String`
  `P_MAXSIZE`
  `static final String`
  `P_MUTATION`
  `static final String`
  `P_NUM_TRIES`

  ### Fields inherited from class ec.gp.GPBreedingPipeline

  `P_NODESELECTOR, P_TREE, TREE_UNFIXED`

  ### Fields inherited from class ec.BreedingPipeline

  `DYNAMIC_SOURCES, likelihood, mybase, P_LIKELIHOOD, P_NUMSOURCES, P_SOURCE, sources, V_SAME, V_STUB`

  ### Fields inherited from class ec.BreedingSource

  `NO_PROBABILITY, P_PROB, probability`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `MutationPipeline()`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `Object`
  `clone()`
  Creates a new individual cloned from a prototype, and suitable to begin use in its own evolutionary context.
  `Parameter`
  `defaultBase()`
  Returns the default base for this prototype.
  `int`
  `numSources()`
  Returns the number of sources to this pipeline.
  `int`
  `produce(int min, int max, int subpopulation, ArrayList<Individual> inds, EvolutionState state, int thread, HashMap<String,Object> misc)`
  Produces n individuals from the given subpopulation and puts them into inds[start...start+n-1], where n = Min(Max(q,min),max), where q is the "typical" number of individuals the BreedingSource produces in one shot, and returns n.
  `void`
  `setup(EvolutionState state, Parameter base)`
  Sets up the BreedingPipeline.
  `boolean`
  `verifyPoints(GPNode inner1, GPNode inner2)`
  Returns true if inner1 can feasibly be swapped into inner2's position

  ### Methods inherited from class ec.gp.GPBreedingPipeline

  `produces`

  ### Methods inherited from class ec.BreedingPipeline

  `fillStubs, finishProducing, individualReplaced, maxChildProduction, minChildProduction, preparePipeline, prepareToProduce, sourcesAreProperForm, typicalIndsProduced`

  ### Methods inherited from class ec.BreedingSource

  `getProbability, pickRandom, setProbability, setupProbabilities`

  ### Methods inherited from class java.lang.Object

  `equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Field Details

  - ### P_NUM_TRIES

    public static final String P_NUM_TRIES
    See Also:
      - Constant Field Values

  - ### P_MAXDEPTH

    public static final String P_MAXDEPTH
    See Also:
      - Constant Field Values

  - ### P_MAXSIZE

    public static final String P_MAXSIZE
    See Also:
      - Constant Field Values

  - ### P_MUTATION

    public static final String P_MUTATION
    See Also:
      - Constant Field Values

  - ### P_BUILDER

    public static final String P_BUILDER
    See Also:
      - Constant Field Values

  - ### P_EQUALSIZE

    public static final String P_EQUALSIZE
    See Also:
      - Constant Field Values

  - ### INDS_PRODUCED

    public static final int INDS_PRODUCED
    See Also:
      - Constant Field Values

  - ### NUM_SOURCES

    public static final int NUM_SOURCES
    See Also:
      - Constant Field Values

  - ### NO_SIZE_LIMIT

    public static final int NO_SIZE_LIMIT
    See Also:
      - Constant Field Values

  - ### nodeselect

    public GPNodeSelector nodeselect
    How the pipeline chooses a subtree to mutate

  - ### builder

    public GPNodeBuilder builder
    How the pipeline builds a new subtree

  - ### maxSize

    public int maxSize
    The largest tree (measured as a nodecount) the pipeline is allowed to form.

- ## Constructor Details

  - ### MutationPipeline

    public MutationPipeline()

- ## Method Details

  - ### defaultBase

    public Parameter defaultBase()
    Description copied from interface: `Prototype`
    Returns the default base for this prototype. This should generally be implemented by building off of the static base() method on the DefaultsForm object for the prototype's package. This should be callable during setup(...).

  - ### numSources

    public int numSources()
    Description copied from class: `BreedingPipeline`
    Returns the number of sources to this pipeline. Called during BreedingPipeline's setup. Be sure to return a value > 0, or DYNAMIC_SOURCES which indicates that setup should check the parameter file for the parameter "num-sources" to make its determination.
    Specified by:
      `numSources` in class `BreedingPipeline`

  - ### clone

    public Object clone()
    Description copied from interface: `Prototype`
    Creates a new individual cloned from a prototype, and suitable to begin use in its own evolutionary context.

    Typically this should be a full "deep" clone. However, you may share certain elements with other objects rather than clone hem, depending on the situation:

    - If you hold objects which are shared with other instances, don't clone them.
    - If you hold objects which must be unique, clone them.
    - If you hold objects which were given to you as a gesture of kindness, and aren't owned by you, you probably shouldn't clone them.
    - DON'T attempt to clone: Singletons, Cliques, or Populations, or Subpopulation.
    - Arrays are not cloned automatically; you may need to clone an array if you're not sharing it with other instances. Arrays have the nice feature of being copyable by calling clone() on them.

    Implementations.

    - If no ancestor of yours implements clone(), and you have no need to do clone deeply, and you are abstract, then you should not declare clone().
    - If no ancestor of yours implements clone(), and you have no need to do clone deeply, and you are not abstract, then you should implement it as follows:

      ``

           public Object clone()
               {
               try
                   {
                   return super.clone();
                   }
               catch ((CloneNotSupportedException e)
                   { throw new InternalError(); } // never happens
               }

    - If no ancestor of yours implements clone(), but you need to deep-clone some things, then you should implement it as follows:

      ``

           public Object clone()
               {
               try
                   {
                   MyObject myobj = (MyObject) (super.clone());

                   // put your deep-cloning code here...
                   }
               catch ((CloneNotSupportedException e)
                   { throw new InternalError(); } // never happens
               return myobj;
               }

    - If an ancestor has implemented clone(), and you also need to deep clone some things, then you should implement it as follows:

      ``

           public Object clone()
               {
               MyObject myobj = (MyObject) (super.clone());

               // put your deep-cloning code here...

               return myobj;
               }

    Specified by:
      `clone` in interface `Prototype`
    Overrides:
      `clone` in class `BreedingPipeline`

  - ### setup

    public void setup(EvolutionState state, Parameter base)
    Description copied from class: `BreedingSource`
    Sets up the BreedingPipeline. You can use state.output.error here because the top-level caller promises to call exitIfErrors() after calling setup. Note that probability might get modified again by an external source if it doesn't normalize right.

    The most common modification is to normalize it with some other set of probabilities, then set all of them up in increasing summation; this allows the use of the fast static BreedingSource-picking utility method, BreedingSource.pickRandom(...). In order to use this method, for example, if four breeding source probabilities are {0.3, 0.2, 0.1, 0.4}, then they should get normalized and summed by the outside owners as: {0.3, 0.5, 0.6, 1.0}.

    Specified by:
      `setup` in interface `Prototype`
    Specified by:
      `setup` in interface `Setup`
    Overrides:
      `setup` in class `BreedingPipeline`
    See Also:
      - `Prototype.setup(EvolutionState,Parameter)`

  - ### verifyPoints

    public boolean verifyPoints(GPNode inner1, GPNode inner2)
    Returns true if inner1 can feasibly be swapped into inner2's position

  - ### produce

    public int produce(int min, int max, int subpopulation, ArrayList<Individual> inds, EvolutionState state, int thread, HashMap<String,Object> misc)
    Description copied from class: `BreedingSource`
    Produces n individuals from the given subpopulation and puts them into inds[start...start+n-1], where n = Min(Max(q,min),max), where q is the "typical" number of individuals the BreedingSource produces in one shot, and returns n. max must be >= min, and min must be >= 1. For example, crossover might typically produce two individuals, tournament selection might typically produce a single individual, etc.
    Specified by:
      `produce` in class `BreedingSource`